"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var TypeDormModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeDormModule = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@typedorm/core");
const type_dorm_service_1 = require("./type-dorm.service");
const type_dorm_util_1 = require("./type-dorm.util");
let TypeDormModule = TypeDormModule_1 = class TypeDormModule {
    /**
     * Reigister typeDorm module for root,
     * use `InjectTypeDorm` to inject TypeDormConnection
     * ```ts
     * constructor(@InjectTypeDorm() private readonly connection: TypeDormConnection)
     * ```
     * @param connectionOptions
     * @returns DynamicModule
     */
    static forRoot(option) {
        const typeDormProvider = {
            provide: (0, type_dorm_util_1.getTypeDormConnectionToken)(option.name),
            useValue: (0, core_1.createConnection)(option),
        };
        return {
            module: TypeDormModule_1,
            providers: [typeDormProvider],
            exports: [typeDormProvider],
        };
    }
    /**
     * Reigister typeDorm module for root async,
     * use `InjectTypeDorm` to inject TypeDormConnection
     * ```ts
     * constructor(@InjectTypeDorm() private readonly connection: TypeDormConnection)
     * ```
     * @param TypeDormModuleAsyncOptions
     * @returns DynamicModule
     */
    static forRootAsync(asyncOptions) {
        const { name } = asyncOptions;
        const typeDormProvider = {
            provide: (0, type_dorm_util_1.getTypeDormConnectionToken)(name),
            useFactory(options) {
                return (0, core_1.createConnection)(options);
            },
            inject: [(0, type_dorm_util_1.getTypeDormConnectionOptionToken)(name)],
        };
        return {
            module: TypeDormModule_1,
            imports: asyncOptions.imports,
            providers: [...this.createAsyncProviders(asyncOptions), typeDormProvider],
            exports: [typeDormProvider],
        };
    }
    /* createAsyncProviders */
    static createAsyncProviders(options) {
        if (!(options.useExisting || options.useFactory || options.useClass)) {
            throw new Error('Invalid configuration. Must provide useFactory, useClass or useExisting');
        }
        if (options.useExisting || options.useFactory) {
            return [this.createAsyncOptionsProvider(options)];
        }
        return [
            this.createAsyncOptionsProvider(options),
            { provide: options.useClass, useClass: options.useClass },
        ];
    }
    /* createAsyncOptionsProvider */
    static createAsyncOptionsProvider({ name, ...options }) {
        var _a, _b;
        if (!(options.useExisting || options.useFactory || options.useClass)) {
            throw new Error('Invalid configuration. Must provide useFactory, useClass or useExisting');
        }
        if (options.useFactory) {
            return {
                provide: (0, type_dorm_util_1.getTypeDormConnectionOptionToken)(name),
                useFactory: options.useFactory,
                inject: (_a = options.inject) !== null && _a !== void 0 ? _a : [],
            };
        }
        return {
            provide: (0, type_dorm_util_1.getTypeDormConnectionOptionToken)(name),
            useFactory(optionsFactory) {
                return optionsFactory.createTypeDormConnectionOptions();
            },
            inject: [(_b = options.useClass) !== null && _b !== void 0 ? _b : options.useExisting],
        };
    }
    /**
     * Reigister typeDorm module for root,
     * do not require using `InjectTypeDorm` to inject TypeDormConnection
     * ```ts
     * constructor(
     *  private readonly connection: TypeDormConnection,
     * ) {}
     * ```
     * @param connectionOptions
     * @returns DynamicModule
     */
    static forRootNonInjection(connectionOptions) {
        const connection = (0, core_1.createConnection)(connectionOptions);
        return {
            module: TypeDormModule_1,
            providers: [
                {
                    provide: type_dorm_service_1.TypeDormConnection,
                    useValue: connection,
                },
            ],
            exports: [type_dorm_service_1.TypeDormConnection],
        };
    }
};
TypeDormModule = TypeDormModule_1 = __decorate([
    (0, common_1.Global)(),
    (0, common_1.Module)({})
], TypeDormModule);
exports.TypeDormModule = TypeDormModule;
